//*****************************************************************************
//*
//*
//*		ExcelImport.cpp
//*
//*
//*****************************************************************************
#include	<stdio.h>
#include	<string.h>
#include	"ExcelImport.h"
#include	"StringChain.h"


#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	S			"S"
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	strzlen		wcslen
#define 	szprintf	swprintf
#else
#define 	S			"s"
#define 	Z(a)		a
#define 	zchar		char
#define 	strzlen		strlen
#define 	szprintf	sprintf
#endif


#define 	LOG_SECTORS		0
#define		LOG_SECFILE 	0
#define 	LOG_FOLDERS		0
#define 	LOG_IN_FILE		0
#define 	LOG_TOKENS		0
#define 	LOG_BINDUMP		0
#define 	LOG_TOKENLIST	0
#define 	LOG_FILENAME	"D:\\eee_%S_"


#if LOG_TOKENS

typedef	struct
	{
	unsigned	uVal;
	const char *pName;
	}ExelToken;

ExelToken   aTokens[] =
        {
        0x0006  ,"FORMULAR: Cell Formula                                    ",
        0x000A  ,"EOF: End of File                                          ",
        0x000C  ,"CALCCOUNT: Iteration Count                                ",
        0x000D  ,"CALCMODE: Calculation Mode                                ",
        0x000E  ,"PRECISION: Precision                                      ",
        0x000F  ,"REFMODE: Reference Mode                                   ",
        0x0010  ,"DELTA: Iteration Increment                                ",
        0x0011  ,"ITERATION: Iteration Mode                                 ",
        0x0012  ,"PROTECT: Protection Flag                                  ",
        0x0013  ,"PASSWORD: Protection Password                             ",
        0x0014  ,"HEADER: Print Header on Each Page                         ",
        0x0015  ,"FOOTER: Print Footer on Each Page                         ",
        0x0016  ,"EXTERNCOUNT: Number of External References                ",
        0x0017  ,"EXTERNSHEET: External Reference                           ",
		0x0018  ,"DEFINEDNAME:                                              ",
        0x0019  ,"WINDOWPROTECT: Windows Are Protected                      ",
        0x001A  ,"VERTICALPAGEBREAKS: Explicit Column Page Breaks           ",
        0x001B  ,"HORIZONTALPAGEBREAKS: Explicit Row Page Breaks            ",
        0x001C  ,"NOTE: Comment Associated with a Cell                      ",
        0x001D  ,"SELECTION: Current Selection                              ",
        0x0022  ,"1904: 1904 Date System                                    ",
        0x0026  ,"LEFTMARGIN: Left Margin Measurement                       ",
        0x0027  ,"RIGHTMARGIN: Right Margin Measurement                     ",
        0x0028  ,"TOPMARGIN: Top Margin Measurement                         ",
        0x0029  ,"BOTTOMMARGIN: Bottom Margin Measurement                   ",
        0x002A  ,"PRINTHEADERS: Print Row/Column Labels                     ",
        0x002B  ,"PRINTGRIDLINES: Print Gridlines Flag                      ",
        0x002F  ,"FILEPASS: File Is Password-Protected                      ",
        0x0031  ,"FONT:                                                     ",
        0x0032  ,"FONT2:                                                    ",
        0x0036  ,"DATATABLE:                                                ",
        0x0037  ,"DATATABLE2:                                               ",
        0x003C  ,"CONTINUE: Continues Long Records                          ",
        0x003D  ,"WINDOW1: Window Information                               ",
        0x0040  ,"BACKUP: Save Backup Version of the File                   ",
        0x0041  ,"PANE: Number of Panes and Their Position                  ",
        0x0042  ,"CODEPAGE: Default Code Page                               ",
        0x004D  ,"PLS: Environment-Specific Print Record                    ",
        0x0050  ,"DCON: Data Consolidation Information                      ",
        0x0051  ,"DCONREF: Data Consolidation References                    ",
        0x0052  ,"DCONNAME: Data Consolidation Named References             ",
        0x0055  ,"DEFCOLWIDTH: Default Width for Columns                    ",
        0x0059  ,"XCT: CRN Record Count                                     ",
        0x005A  ,"CRN: Nonresident Operands                                 ",
        0x005B  ,"FILESHARING: File-Sharing Information                     ",
        0x005C  ,"WRITEACCESS: Write Access User Name                       ",
        0x005D  ,"OBJ: Describes a Graphic Object                           ",
        0x005E  ,"UNCALCED: Recalculation Status                            ",
        0x005F  ,"SAVERECALC: Recalculate Before Save                       ",
        0x0060  ,"TEMPLATE: Workbook Is a Template                          ",
        0x0063  ,"OBJPROTECT: Objects Are Protected                         ",
        0x007D  ,"COLINFO: Column Formatting Information                    ",
        0x007E  ,"RK: Cell Value, RK Number                                 ",
        0x007F  ,"IMDATA: Image Data                                        ",
        0x0080  ,"GUTS: Size of Row and Column Gutters                      ",
        0x0081  ,"WSBOOL: Additional Workspace Information                  ",
        0x0082  ,"GRIDSET: State Change of Gridlines Option                 ",
        0x0083  ,"HCENTER: Center Between Horizontal Margins                ",
        0x0084  ,"VCENTER: Center Between Vertical Margins                  ",
        0x0085  ,"BOUNDSHEET: Sheet Information                             ",
        0x0086  ,"WRITEPROT: Workbook Is Write-Protected                    ",
        0x0087  ,"ADDIN: Workbook Is an Add-in Macro                        ",
        0x0088  ,"EDG: Edition Globals                                      ",
        0x0089  ,"PUB: Publisher                                            ",
        0x008C  ,"COUNTRY: Default Country and WIN.INI Country              ",
        0x008D  ,"HIDEOBJ: Object Display Options                           ",
        0x0090  ,"SORT: Sorting Options                                     ",
        0x0091  ,"SUB: Subscriber                                           ",
        0x0092  ,"PALETTE: Color Palette Definition                         ",
        0x0094  ,"LHRECORD: .WK? File Conversion Information                ",
        0x0095  ,"LHNGRAPH: Named Graph Information                         ",
        0x0096  ,"SOUND: Sound Note                                         ",
        0x0098  ,"LPR: Sheet Was Printed Using LINE.PRINT(                  ",
        0x0099  ,"STANDARDWIDTH: Standard Column Width                      ",
        0x009A  ,"FNGROUPNAME: Function Group Name                          ",
        0x009B  ,"FILTERMODE: Sheet Contains Filtered List                  ",
        0x009C  ,"FNGROUPCOUNT: Built-in Function Group Count               ",
        0x009D  ,"AUTOFILTERINFO: Drop-Down Arrow Count                     ",
        0x009E  ,"AUTOFILTER: AutoFilter Data                               ",
        0x00A0  ,"SCL: Window Zoom Magnification                            ",
        0x00A1  ,"SETUP: Page Setup                                         ",
        0x00A9  ,"COORDLIST: Polygon Object Vertex Coordinates              ",
        0x00AB  ,"GCW: Global Column-Width Flags                            ",
        0x00AE  ,"SCENMAN: Scenario Output Data                             ",
        0x00AF  ,"SCENARIO: Scenario Data                                   ",
        0x00B0  ,"SXVIEW: View Definition                                   ",
        0x00B1  ,"SXVD: View Fields                                         ",
        0x00B2  ,"SXVI: View Item                                           ",
        0x00B4  ,"SXIVD: Row/Column Field IDs                               ",
        0x00B5  ,"SXLI: Line Item Array                                     ",
        0x00B6  ,"SXPI: Page Item                                           ",
        0x00B8  ,"DOCROUTE: Routing Slip Information                        ",
        0x00B9  ,"RECIPNAME: Recipient Name                                 ",
        0x00BC  ,"SHRFMLA: Shared Formula                                   ",
        0x00BD  ,"MULRK: Multiple RK Cells                                  ",
        0x00BE  ,"MULBLANK: Multiple Blank Cells                            ",
        0x00C1  ,"MMS: ADDMENU/DELMENU Record Group Count                   ",
        0x00C2  ,"ADDMENU: Menu Addition                                    ",
        0x00C3  ,"DELMENU: Menu Deletion                                    ",
        0x00C5  ,"SXDI: Data Item                                           ",
        0x00C6  ,"SXDB: PivotTable Cache Data                               ",
        0x00CD  ,"SXSTRING: String                                          ",
        0x00D0  ,"SXTBL: Multiple Consolidation Source Info                 ",
        0x00D1  ,"SXTBRGIITM: Page Item Name Count                          ",
        0x00D2  ,"SXTBPG: Page Item Indexes                                 ",
        0x00D3  ,"OBPROJ: Visual Basic Project                              ",
        0x00D5  ,"SXIDSTM: Stream ID                                        ",
        0x00D6  ,"RSTRING: Cell with Character Formatting                   ",
        0x00D7  ,"DBCELL: Stream Offsets                                    ",
        0x00DA  ,"BOOKBOOL: Workbook Option Flag                            ",
        0x00DC  ,"PARAMQRY: Query Parameters                                ",
        0x00DC  ,"SXEXT: External Source Information                        ",
        0x00DD  ,"SCENPROTECT: Scenario Protection                          ",
        0x00DE  ,"OLESIZE: Size of OLE Object                               ",
        0x00DF  ,"UDDESC: Description String for Chart Autoformat           ",
        0x00E0  ,"XF: Extended Format                                       ",
        0x00E1  ,"INTERFACEHDR: Beginning of User Interface Records         ",
        0x00E2  ,"INTERFACEEND: End of User Interface Records               ",
        0x00E3  ,"SXVS: View Source                                         ",
        0x00E5  ,"MERGECELLS: Merged Cells                                  ",
        0x00EA  ,"TABIDCONF: Sheet Tab ID of Conflict History               ",
        0x00EB  ,"MSODRAWINGGROUP: Microsoft Office Drawing Group           ",
        0x00EC  ,"MSODRAWING: Microsoft Office Drawing                      ",
        0x00ED  ,"MSODRAWINGSELECTION: Microsoft Office Drawing Selection   ",
        0x00F0  ,"SXRULE: PivotTable Rule Data                              ",
        0x00F1  ,"SXEX: PivotTable View Extended Information                ",
        0x00F2  ,"SXFILT: PivotTable Rule Filter                            ",
        0x00F4  ,"SXDXF: Pivot Table Formatting                             ",
        0x00F5  ,"SXITM: Pivot Table Item Indexes                           ",
        0x00F6  ,"SXNAME: PivotTable Name                                   ",
        0x00F7  ,"SXSELECT: PivotTable Selection Information                ",
        0x00F8  ,"SXPAIR: PivotTable Name Pair                              ",
        0x00F9  ,"SXFMLA: Pivot Table Parsed Expression                     ",
        0x00FB  ,"SXFORMAT: PivotTable Format Record                        ",
        0x00FC  ,"SST: Shared String Table                                  ",
        0x00FD  ,"LABELSST: Cell Value, String Constant/SST                 ",
        0x00FF  ,"EXTSST: Extended Shared String Table                      ",
        0x0100  ,"SXVDEX: Extended PivotTable View Fields                   ",
        0x0103  ,"SXFORMULA: PivotTable Formula Record                      ",
        0x0122  ,"SXDBEX: PivotTable Cache Data                             ",
        0x013D  ,"TABID: Sheet Tab Index Array                              ",
        0x0160  ,"USESELFS: Natural Language Formulas Flag                  ",
        0x0161  ,"DSF: Double Stream File                                   ",
        0x0162  ,"XL5MODIFY: Flag for DSF                                   ",
        0x01A5  ,"FILESHARING2: File-Sharing Information for Shared Lists   ",
        0x01A9  ,"USERBVIEW: Workbook Custom View Settings                  ",
        0x01AA  ,"USERSVIEWBEGIN: Custom View Settings                      ",
        0x01AB  ,"USERSVIEWEND: End of Custom View Records                  ",
        0x01AD  ,"QSI: External Data Range                                  ",
        0x01AE  ,"SUPBOOK: Supporting Workbook                              ",
        0x01AF  ,"PROT4REV: Shared Workbook Protection Flag                 ",
        0x01B0  ,"CONDFMT: Conditional Formatting Range Information         ",
        0x01B1  ,"CF: Conditional Formatting Conditions                     ",
        0x01B2  ,"DVAL: Data Validation Information                         ",
        0x01B5  ,"DCONBIN: Data Consolidation Information                   ",
        0x01B6  ,"TXO: Text Object                                          ",
        0x01B7  ,"REFRESHALL: Refresh Flag                                  ",
        0x01B8  ,"HLINK: Hyperlink                                          ",
		0x01BA  ,"CODENAME:                                                 ",
        0x01BB  ,"SXFDBTYPE: SQL Datatype Identifier                        ",
        0x01BC  ,"PROT4REVPASS: Shared Workbook Protection Password         ",
        0x01BE  ,"DV: Data Validation Criteria                              ",
        0x01C0  ,"EXCEL9FILE: Excel 9 File                                  ",
        0x01C1  ,"RECALCID: Recalc Information                              ",
        0x0200  ,"DIMENSIONS: Cell Table Size                               ",
        0x0201  ,"BLANK: Cell Value, Blank Cell                             ",
        0x0203  ,"NUMBER: Cell Value, Floating-Point Number                 ",
        0x0204  ,"LABEL: Cell Value, String Constant                        ",
        0x0205  ,"BOOLERR: Cell Value, Boolean or Error                     ",
        0x0207  ,"STRING: String Value of a Formula                         ",
        0x0208  ,"ROW: Describes a Row                                      ",
        0x020B  ,"INDEX: Index Record                                       ",
        0x0218  ,"NAME: Defined Name                                        ",
        0x0221  ,"ARRAY: Array-Entered Formula                              ",
        0x0223  ,"EXTERNNAME: Externally Referenced Name                    ",
        0x0225  ,"DEFAULTROWHEIGHT: Default Row Height                      ",
        0x0231  ,"FONT: Font Description                                    ",
        0x0236  ,"TABLE: Data Table                                         ",
        0x023E  ,"WINDOW2: Sheet Window Information                         ",
		0x027E  ,"RK: Contains an RK value                                  ",
        0x0293  ,"STYLE: Style Information                                  ",
        0x0406  ,"FORMULA: Cell Formula                                     ",
        0x041E  ,"FORMAT: Number Format                                     ",
		0x04BC  ,"SHAREDFMLA:                                               ",
        0x0800  ,"HLINKTOOLTIP: Hyperlink Tooltip                           ",
        0x0801  ,"WEBPUB: Web Publish Item                                  ",
        0x0802  ,"QSISXTAG: PivotTable and Query Table Extensions           ",
        0x0803  ,"DBQUERYEXT: Database Query Extensions                     ",
        0x0804  ,"EXTSTRING: FRT String                                     ",
        0x0805  ,"TXTQUERY: Text Query Information                          ",
        0x0806  ,"QSIR: Query Table Formatting                              ",
        0x0807  ,"QSIF: Query Table Field Formatting                        ",
        0x0809  ,"BOF: Beginning of File                                    ",
        0x080A  ,"OLEDBCONN: OLE Database Connection                        ",
        0x080B  ,"WOPT: Web Options                                         ",
        0x080C  ,"SXVIEWEX: Pivot Table OLAP Extensions                     ",
        0x080D  ,"SXTH: PivotTable OLAP Hierarchy                           ",
        0x080E  ,"SXPIEX: OLAP Page Item Extensions                         ",
        0x080F  ,"SXVDTEX: View Dimension OLAP Extensions                   ",
        0x0810  ,"SXVIEWEX9: Pivot Table Extensions                         ",
        0x0812  ,"CONTINUEFRT: Continued FRT                                ",
        0x0813  ,"REALTIMEDATA: Real-Time Data (RTD)                        ",
        0x0862  ,"SHEETEXT: Extra Sheet Info                                ",
        0x0863  ,"BOOKEXT: Extra Book Info                                  ",
        0x0864  ,"SXADDL: Pivot Table Additional Info                       ",
        0x0865  ,"CRASHRECERR: Crash Recovery Error                         ",
        0x0866  ,"HFPicture: Header / Footer Picture                        ",
        0x0867  ,"FEATHEADR: Shared Feature Header                          ",
        0x0868  ,"FEAT: Shared Feature Record                               ",
        0x086A  ,"DATALABEXT: Chart Data Label Extension                    ",
        0x086B  ,"DATALABEXTCONTENTS: Chart Data Label Extension Contents   ",
        0x086C  ,"CELLWATCH: Cell Watch                                     ",
        0x086d  ,"FEATINFO: Shared Feature Info Record                      ",
        0x0871  ,"FEATHEADR11: Shared Feature Header 11                     ",
        0x0872  ,"FEAT11: Shared Feature 11 Record                          ",
        0x0873  ,"FEATINFO11: Shared Feature Info 11 Record                 ",
        0x0874  ,"DROPDOWNOBJIDS: Drop Down Object                          ",
        0x0875  ,"CONTINUEFRT11: Continue FRT 11                            ",
        0x0876  ,"DCONN: Data Connection                                    ",
        0x0877  ,"LIST12: Extra Table Data Introduced in Excel 2007         ",
        0x0878  ,"FEAT12: Shared Feature 12 Record                          ",
        0x0879  ,"CONDFMT12: Conditional Formatting Range Information 12    ",
        0x087A  ,"CF12: Conditional Formatting Condition 12                 ",
        0x087B  ,"CFEX: Conditional Formatting Extension                    ",
        0x087C  ,"XFCRC: XF Extensions Checksum                             ",
        0x087D  ,"XFEXT: XF Extension                                       ",
        0x087E  ,"EZFILTER12: AutoFilter Data Introduced in Excel 2007      ",
        0x087F  ,"CONTINUEFRT12: Continue FRT 12                            ",
        0x0881  ,"SXADDL12: Additional Workbook Connections Information     ",
        0x0884  ,"MDTINFO: Information about a Metadata Type                ",
        0x0885  ,"MDXSTR: MDX Metadata String                               ",
        0x0886  ,"MDXTUPLE: Tuple MDX Metadata                              ",
        0x0887  ,"MDXSET: Set MDX Metadata                                  ",
        0x0888  ,"MDXPROP: Member Property MDX Metadata                     ",
        0x0889  ,"MDXKPI: Key Performance Indicator MDX Metadata            ",
        0x088A  ,"MDTB: Block of Metadata Records                           ",
        0x088B  ,"PLV: Page Layout View Settings in Excel 2007              ",
        0x088C  ,"COMPAT12: Compatibility Checker 12                        ",
        0x088D  ,"DXF: Differential XF                                      ",
        0x088E  ,"TABLESTYLES: Table Styles                                 ",
        0x088F  ,"TABLESTYLE: Table Style                                   ",
        0x0890  ,"TABLESTYLEELEMENT: Table Style Element                    ",
        0x0892  ,"STYLEEXT: Named Cell Style Extension                      ",
        0x0893  ,"NAMEPUBLISH: Publish To Excel Server Data for Name        ",
        0x0894  ,"NAMECMT: Name Comment                                     ",
        0x0895  ,"SORTDATA12: Sort Data 12                                  ",
        0x0896  ,"THEME: Theme                                              ",
        0x0897  ,"GUIDTYPELIB: VB Project Typelib GUID                      ",
        0x0898  ,"FNGRP12: Function Group                                   ",
        0x0899  ,"NAMEFNGRP12: Extra Function Group                         ",
        0x089A  ,"MTRSETTINGS: Multi-Threaded Calculation Settings          ",
        0x089B  ,"COMPRESSPICTURES: Automatic Picture Compression Mode      ",
        0x089C  ,"HEADERFOOTER: Header Footer                               ",
        0x08A3  ,"FORCEFULLCALCULATION: Force Full Calculation Settings     ",
        0x08C1  ,"LISTOBJ: List Object                                      ",
        0x08C2  ,"LISTFIELD: List Field                                     ",
        0x08C3  ,"LISTDV: List Data Validation                              ",
        0x08C4  ,"LISTCONDFMT: List Conditional Formatting                  ",
        0x08C5  ,"LISTCF: List Cell Formatting                              ",
        0x08C6  ,"FMQRY: Filemaker queries                                  ",
        0x08C7  ,"FMSQRY: File maker queries                                ",
        0x08C8  ,"PLV: Page Layout View in Mac Excel 11                     ",
        0x08C9  ,"LNEXT: Extension information for borders in Mac Office 11 ",
        0x08CA  ,"MKREXT: Extension information for markers in Mac Office 11",
        0x08CB  ,"CRTCOOPT: Color options for Chart series in Mac Office 11 ",
        0,0,
		};

#endif

typedef struct
	{
	unsigned char 	aAbSig[8];					// [000H,08] {0xd0, 0xcf, 0x11, 0xe0, 0xa1, 0xb1, 0x1a, 0xe1}
												// was       {0x0e, 0x11, 0xfc, 0x0d, 0xd0, 0xcf, 0x11, 0xe0}
	unsigned char 	aClid[16];					// [008H,16] class id (set with WriteClassStg, retrieved with GetClassFile/ReadClassStg)
	unsigned short 	uMinorVersion;				// [018H,02] minor version of the format: 33 is written by reference implementation
	unsigned short 	uDllVersion;				// [01AH,02] major version of the dll/format: 3 is written by reference implementation
	unsigned short 	uByteOrder;					// [01CH,02] 0xFFFE: indicates Intel byte-ordering
	unsigned short 	uSectorShift;				// [01EH,02] size of sectors in power-of-two (typically 9, indicating 512-byte sectors)
	unsigned short 	uMiniSectorShift;			// [020H,02] size of mini-sectors in power-of-two (typically 6, indicating 64-byte mini-sectors)
	unsigned short 	usReserved;					// [022H,02] reserved, must be zero
	unsigned 		ulReserved1;				// [024H,04] reserved, must be zero
	unsigned 		ulReserved2;				// [028H,04] reserved, must be zero
	unsigned		uSectFat;					// [02CH,04] number of SECTs in the FAT chain
	unsigned		uSectDirStart;				// [030H,04] first SECT in the Directory chain
	unsigned		uSignature;					// [034H,04] signature used for transactionin: must be zero. The reference implementation does not support transactioning
	unsigned		uMiniSectorCutoff;			// [038H,04] maximum size for mini-streams: typically 4096 bytes Windows Compound Binary File Format Specification Page 3 of 9
	unsigned		uSectMiniFatStart;			// [03CH,04] first SECT in the mini-FAT chain
	unsigned		uSectMiniFat;				// [040H,04] number of SECTs in the mini-FAT chain
	unsigned		uSectDifStart;				// [044H,04] first SECT in the DIF chain
	unsigned		uSectDif;					// [048H,04] number of SECTs in the DIF chain
	unsigned		aSectFatList[109];			// [04CH,436] the SECTs of the first 109 FAT sectors
	}StorageHeader;


typedef struct
	{
	wchar_t			cName[32];					// [000H,64] 64 bytes. The Element name in Unicode, padded with zeros to fill this byte array
	unsigned short	uNameSize;					// [040H,02] Length of the Element name in characters, not bytes
	unsigned char	ucMse;						// [042H,01] Type of object: value taken from the STGTY enumeration
	unsigned char	ucFlags;					// [043H,01] Value taken from DECOLOR enumeration.
	unsigned		uSidLeftSib;				// [044H,04] SID of the left-sibling of this entry in the directory tree
	unsigned		uSidRightSib;				// [048H,04] SID of the right-sibling of this entry in the directory tree
	unsigned		uSidChild;					// [04CH,04] SID of the child acting as the root of all the children of this
	unsigned char	aClsId[16];					// [050H,16] CLSID of this storage (if _mse=STGTY_STORAGE)
	unsigned		uUserFlags;					// [060H,04] User flags of this storage (if _mse=STGTY_STORAGE)
	unsigned		aTime[4];					// [064H,16] Create/Modify time-stamps (if _mse=STGTY_STORAGE)
	unsigned		uSectStart;					// [074H,04] starting SECT of the stream (if _mse=STGTY_STREAM)
	unsigned		uSize;						// [078H,04] size of stream in bytes (if _mse=STGTY_STREAM)
	unsigned short	uSptPropType;				// [07CH,02] Reserved for future use. Must be zero.
	}DirectoryEntry;




//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CExcelImport::CExcelImport()
{

	m_pFileMem		= 0;
	m_uFileSize		= 0;
	m_pFatList		= 0;
	m_pMinList		= 0;
	m_pCallbackProc	= ImportDummy;

	SetPassword(Z("VelvetSweatshop"));

}

//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CExcelImport::~CExcelImport()
{

	Clear();

}

//*****************************************************************************
//*
//*		StreamRead
//*
//*****************************************************************************
int _cdecl CExcelImport::StreamRead(void *pHandel,void *pBuffer,int iCount)
{
BufferStream   *pStream=(BufferStream*)pHandel;
char		   *pData;
char		   *pOut;
unsigned		uAdr;
unsigned		uMax;
unsigned		uNum;
unsigned		uOff;
unsigned		uLen;




	if(iCount<=0)return 0;

	uMax = pStream->uStreamSize-pStream->uOffset;

	if((unsigned)iCount>=uMax)
		{
		iCount = uMax;
		}



	pOut  = (char*)pBuffer;

	while(iCount>0) 											// Daten sektorweise lesen
		{
		if(pStream->uSector>=pStream->uSectorCount)
			{
			break;
			}

		uOff = pStream->uOffset&(pStream->uSectorSize-1);
		uNum = pStream->uSectorSize-uOff;

		if(uNum>(unsigned)iCount)uNum=iCount;

		if(pStream->uIsMin)
			{
			uAdr  = pStream->pMinAddress[pStream->uSector];
			pData = pStream->pBaseData+uAdr;
			}
		else{
			pData = pStream->pBaseData+pStream->uSectorSize*pStream->uSector;
			}

		memcpy(pOut,pData+uOff,uNum);

		iCount			   -= uNum;
		pOut			   += uNum;
		pStream->uOffset   += uNum;


		if(uOff+uNum>=pStream->uSectorSize) 					// Schon auf neuem Sektor
			{
			if(pStream->uSector>=pStream->uSectorCount)
				{
				break;
				}

			pStream->uSector = pStream->pFatEntries[pStream->uSector];
			}
		}

	uLen = pOut-(char*)pBuffer;


return uLen;	
}

//*****************************************************************************
//*
//*		SetCallback
//*
//*****************************************************************************
//	Stellt den Callback fr gefundene Zellen ein
//	pParam,ExcelImportCB *pProc
void CExcelImport::SetCallback(void *pParam,ExcelImportCB pProc)
{

	m_pCallbackParam	= pParam;
	m_pCallbackProc		= pProc;

	if(!m_pCallbackProc)m_pCallbackProc=ImportDummy;

}

//*****************************************************************************
//*
//*		StreamSeek
//*
//*****************************************************************************
int _cdecl CExcelImport::StreamSeek(void *pHandel,int iPos,int iMode)
{
BufferStream   *pStream=(BufferStream*)pHandel;



	switch(iMode)
		{
	case SEEK_CUR:	iPos += pStream->uOffset;		break;
	case SEEK_END:	iPos += pStream->uStreamSize;	break;
		}



	if(iPos==(int)pStream->uOffset)return iPos;


	if(iPos>(int)pStream->uStreamSize)iPos=pStream->uStreamSize;
	if(iPos<0)iPos=0;


														// Verschub im aktuellen Sektor
	if(iPos/pStream->uSectorSize==(int)pStream->uOffset/pStream->uSectorSize)
		{
		pStream->uOffset = iPos;
		return iPos;
		}

														// Verschub Richtung Dateibeginn
	if(iPos/pStream->uSectorSize<(int)pStream->uOffset/pStream->uSectorSize)
		{
		pStream->uSector = pStream->pFatEntries[pStream->uStartSector];
		pStream->uOffset = 0;
		}
														// Verschub Richtung Dateiende
	while(iPos/pStream->uSectorSize>(int)pStream->uOffset/pStream->uSectorSize)
		{
		if(pStream->uSector>=pStream->uSectorCount)
			{
			break;
			}

		pStream->uSector  = pStream->pFatEntries[pStream->uSector];
		pStream->uOffset += pStream->uSectorSize;
		}

	pStream->uOffset = iPos;



return iPos;
}

//*****************************************************************************
//*
//*		CreateStream
//*
//*****************************************************************************
//	Erzeugt einen neuen Lese-Stream
//	uStart		: Ist der Startsektor in der FAT
//	uLength		: Ist die Lnge des Stream in Byte
//	bUseMin		: Soll die kleine FAT verwentet werden.
//	Ergibt einen Zeiger auf den Stream
CFileBuffer *CExcelImport::CreateStream(unsigned uStart,unsigned uLength,bool bUseMin)
{
BufferStream   *pStream;
unsigned		uSector;
unsigned		uPos;
unsigned		uNum;



	pStream = new BufferStream;


	pStream->pFatEntries	= (bUseMin)? m_pMinList:m_pFatList;
	pStream->pMinAddress    = m_pMinAddr;
	pStream->pBaseData		= m_pFileMem+512;
	pStream->uStartSector	= uStart;
	pStream->uSectorCount	= (bUseMin)? m_uMinCount:m_uFatCount;
	pStream->uSectorSize	= (bUseMin)? m_uMinSize :m_uSecSize;
	pStream->uStreamSize	= uLength;
	pStream->uOffset		= 0;
	pStream->uSector		= uStart;
	pStream->uIsMin		   =  bUseMin;


	uSector = pStream->uStartSector;						// Prfe die FAT-Kette

	for(uPos=0,uNum=0;uPos<uLength;uPos+=pStream->uSectorSize,uNum++)
		{
		if(uSector>=pStream->uSectorCount)					// Fehler in FAT-Kette;
			{
			delete pStream;
			return 0;
			}

		uSector = pStream->pFatEntries[uSector];
		}


	pStream->sStream.OpenProc(pStream,StreamRead,0,0,StreamSeek);


return &pStream->sStream;
}

//*****************************************************************************
//*
//*		DeleteStream
//*
//*****************************************************************************
//	Lscht einen Lese-Stream wieder
//	pStream		: Zeiger auf den Stream
//	Ergibt 0 wenn erfolgreich, bzw. eine Fehlernummer grer 0
int	CExcelImport::DeleteStream(CFileBuffer *pStream)
{

	if(!pStream)return 1;


	pStream->Close();
	delete pStream;



return 0;
}

//*****************************************************************************
//*
//*		Clear
//*
//*****************************************************************************
void CExcelImport::Clear()
{

	if(m_pFatList)
		{
		delete m_pFatList;
		m_pFatList  = 0;
		}


	if(m_pMinList)
		{
		delete m_pMinList;
		m_pMinList	= 0;
		}


	m_sFile.Close();
	m_pFileMem	= 0;
	m_uFileSize	= 0;

}

//*****************************************************************************
//*
//*		Open
//*
//*****************************************************************************
//	ffnet eine Excel-Datei.
//	pFilename		: Ist der Name der Excel-Datei.
//	Ergibt 0 wenn die Datei geffnet wurde, bzw. einen Fehler-Code:
//						1 = Datei konnte nicht geffnet werden.
//						2 = Falsches Dateiformat.
//						3 = BigEndian wird nicht untersttzt
//						4 = Zu wenig Speicher.
//						5 = Die Datei wird von einem anderen Programm benutzt
//						6 = Falsche BIFF-Version
//						7 = LOG-Datei konnte nicht geffnet werden
//						8 = Die Datei kann nicht decodiert werden
//						9 = Falsches Password
int	CExcelImport::Open(const zchar *pFilename)
{
CFileBuffer		   *pDir;
DirectoryEntry	   *pDirPtr;
StorageHeader	   *pHeader;
char			   *pSector;
unsigned 		   *pEntry;
unsigned			uNext;
unsigned			uSize;
unsigned			uOff;
unsigned			uPos;
unsigned			uSub;
unsigned			uDif;
unsigned			uMax;
unsigned			uDir;
unsigned			uRet;
unsigned			uVal;



		m_pFileMem = m_sFile.Open(pFilename,CMF_READ);
	if(!m_pFileMem)
		{
		if(GetFileAttributes(pFilename)==0xFFFFFFFF)return 5;
		return 1;
		}

	m_uFileSize	= m_sFile.GetLength();

	if(m_uFileSize<1024)
		{
		Clear();
		return 2;
		}


	if(memcmp(m_pFileMem,"\xD0\xCF\x11\xE0\xA1\xB1\x1A\xE1",8))
	if(memcmp(m_pFileMem,"\x0E\x11\xFC\x0D\xD0\xCF\x11\xE0",8))
		{
		Clear();
		return 2;
		}


	pHeader = (StorageHeader*)m_pFileMem;

	if(pHeader->uByteOrder!=0xFFFE)
		{
		Clear();
		return 3;
		}

	m_uSecSize	= 1<<pHeader->uSectorShift;
	m_uMinSize	= 1<<pHeader->uMiniSectorShift;


//******************** FAT laden **********************************************

	uRet	= 0;
	uMax	= 109;
	uSize	= 1<<pHeader->uSectorShift;
	pEntry	= pHeader->aSectFatList;

	m_pFatList	= new unsigned[pHeader->uSectFat*uSize/4];

	if(!m_pFatList)
		{
		Clear();
		return 4;
		}



	if(uMax>pHeader->uSectFat)
		{
		uMax = pHeader->uSectFat;
		}

	for(uOff=0,uPos=0;uPos<uMax;uPos++,uOff++)				// FAT aus den ersten 109 Eintrgen
		{
		pSector  = m_pFileMem+512;
		pSector	+= pEntry[uPos]*uSize;
		memcpy(m_pFatList+uOff*uSize/4,pSector,uSize);
		}


	uNext = pHeader->uSectDifStart;
	uMax  = uSize/4-1;

	while(uOff<pHeader->uSectFat)							// FAT aus weiteren Eintrgen
		{
		pSector  = m_pFileMem+512;
		pSector	+= uNext*uSize;
		pEntry	 = (unsigned*)pSector;

		if(uOff+uMax>pHeader->uSectFat)
			{
			uMax = pHeader->uSectFat-uOff;
			}

		for(uPos=0;uPos<uMax;uPos++,uOff++)
			{
			pSector  = m_pFileMem+512;
			pSector	+= pEntry[uPos]*uSize;
			memcpy(m_pFatList+uOff*uSize/4,pSector,uSize);
			}


		uNext = pEntry[uPos];
		}


	m_uFatCount = pHeader->uSectFat*uSize/4;


//******************** Kleine FAT laden ***************************************

	uVal		= pHeader->uSectMiniFat*uSize/4;
	m_pMinList	= new unsigned[uVal*2+4];
	m_pMinAddr	= m_pMinList+1+uVal;
 
	if(!m_pMinList)
		{
		Clear();
		return 4;
		}

	uNext	= pHeader->uSectMiniFatStart;
 
	for(uPos=0;uPos<pHeader->uSectMiniFat;uPos++)				// FAT aus weiteren Eintrgen
		{
		pSector 	= m_pFileMem+512;
		pSector    += uNext*uSize;
 
		memcpy(m_pMinList+uPos*uSize/4,pSector,uSize);
 
		uNext = m_pFatList[uNext];
		}
 
 
 	pDirPtr		= (DirectoryEntry*)(m_pFileMem+512+pHeader->uSectDirStart*m_uSecSize);
	m_uMinCount	= pHeader->uSectMiniFat*uSize/4;
	uNext		= pDirPtr->uSectStart;
	uDif		= m_uSecSize/m_uMinSize;
	uSub		= 0;
 
 
	for(uPos=0;uPos<m_uMinCount;uPos++,uSub++)					// Kleine Sektoren umrechen
		{
		if(uSub>=uDif)
			{
			uSub = 0;
 
			if(uNext&0x80000000)
					uNext = 0xFFFFFFF0;
			else	uNext = m_pFatList[uNext];
			}
 
		m_pMinAddr[uPos] = uNext*m_uSecSize+uSub*m_uMinSize;
		}


//*****************************************************************************


	#if LOG_SECTORS

	for(uPos=0;uPos<pHeader->uSectFat*128;uPos++)
		{
		printf("%i\t= %i\n",uPos,m_pFatList[uPos]);
		}


	printf("\n\nMin:\n");

	for(uPos=0;uPos<pHeader->uSectMiniFat*uSize/4;uPos++)
		{
		printf("%i\t= %i\n",uPos,m_pMinList[uPos]);
		}

	#endif

	#if LOG_SECFILE

	FILE   *pSecFile;

	   pSecFile=fopen(LOG_FILENAME"_FAT.txt","wb");
	if(pSecFile)
		{
		for(uPos=0;uPos<pHeader->uSectFat*128;uPos++)
			{
			fprintf(pSecFile,"%Xh\t= %Xh\n",uPos,m_pFatList[uPos]);
			}

		fprintf(pSecFile,"\n\nMin:\n");

		for(uPos=0;uPos<pHeader->uSectMiniFat*uSize/4;uPos++)
			{
			fprintf(pSecFile,"%i\t= %i\n",uPos,m_pMinList[uPos]);
			}
		
		fclose(pSecFile);
		}

	#endif

	uNext = pHeader->uSectDirStart;

	for(uDir=0;;uDir++)										// Berechne die Gre des Verzeichnisses
		{
		if(uNext&0x80000000)break;
		uNext = m_pFatList[uNext];
		}



	pDir  = CreateStream(pHeader->uSectDirStart,uDir*uSize);
	uNext = pHeader->uSectDirStart;


	for(uDir=0;;uDir++)										// Das Verzeichnis einlesen
		{
		DirectoryEntry	sDir;
		CFileBuffer    *pOut;
		char			cName[512];
		int				iNum;


		pDir->Seek(uDir*128);

		if(pDir->Read(&sDir,sizeof(sDir))!=sizeof(sDir))
			{
			break;
			}


		#if LOG_FOLDERS
		printf("%i\t%S(%i,%i)\n",uDir,sDir.cName,sDir.uSectStart,sDir.uSize);
		#endif


		if(sDir.ucMse==2 && sDir.uSize>=pHeader->uMiniSectorCutoff)
			{
			#if LOG_BINDUMP

				pOut = CreateStream(sDir.uSectStart,sDir.uSize,sDir.uSize<pHeader->uMiniSectorCutoff);
			if(!pOut)continue;

			FILE   *pFile;
			szprintf(cName,LOG_FILENAME".bin",sDir.cName);
			if(cName[7]<=' ')cName[7]='X';
			
				pFile=fopen(cName,"wb");
			if(!pFile)
				{
				DeleteStream(pOut);
				continue;
				}

			for(uOff=0;;uOff+=512)
				{
					iNum = pOut->Read(cName,512);
				if(!iNum)break;
				fwrite(cName,1,iNum,pFile);
				}

			fclose(pFile);
			DeleteStream(pOut);

			#endif

			#if LOG_TOKENLIST

			if(uDir==1)
				{
				FILE   *pFile;

					pOut = CreateStream(sDir.uSectStart,sDir.uSize,sDir.uSize<pHeader->uMiniSectorCutoff);
				if(!pOut)continue;

				szprintf(cName,LOG_FILENAME"token.txt",sDir.cName);
				if(cName[7]<=' ')cName[7]='X';

					pFile=fopen(cName,"wb");
				if(!pFile)
					{
					DeleteStream(pOut);
					continue;
					}

				for(;;)
					{
					unsigned uVal,uNum;
					const char *pName="???";


						iNum = pOut->Read(cName,4);
					if(!iNum)break;

					uVal = *(WORD*)(cName+0);

					for(uNum=0;aTokens[uNum].pName;uNum++)
						{
						if(aTokens[uNum].uVal!=uVal)continue;
						pName = aTokens[uNum].pName;
						break;
						}

					fprintf(pFile,"%04X  %007u [%5u]\t= \"%s\"  \n",uVal,pOut->Tell(),*(WORD*)(cName+2),pName);
					pOut->Seek(*(WORD*)(cName+2),SEEK_CUR);
					}

				fclose(pFile);
				DeleteStream(pOut);
				}

			#endif


			   pOut = CreateStream(sDir.uSectStart,sDir.uSize,sDir.uSize<pHeader->uMiniSectorCutoff);
			if(pOut)
				{
				   iNum = pOut->Read(cName,4);
				if(iNum==4 && cName[0]==9 && cName[1]==8)
					{
					pOut->Seek(0);
					uVal = ImportData(pOut,sDir.cName);
					if(uVal)uRet=uVal;
					}

				DeleteStream(pOut);
				}
			}
		}


	if(pDir)DeleteStream(pDir);


return uRet;
}

//*****************************************************************************
//*
//*		ReadByte
//*
//*****************************************************************************
inline int CExcelImport::ReadByte()
{
char	cValue;


	if(!m_iDecode)
		{
		m_iOffset += 1;
		return m_pStream->ReadByte();
		}


	Read(&cValue,1);


return cValue;
}

//*****************************************************************************
//*
//*		ReadWord
//*
//*****************************************************************************
inline int CExcelImport::ReadWord()
{
short 	sValue;


	if(!m_iDecode)
		{
		m_iOffset += 2;
		return m_pStream->ReadWord();
		}

	Read(&sValue,2);


return sValue;
}

//*****************************************************************************
//*
//*		ReadDWord
//*
//*****************************************************************************
inline int CExcelImport::ReadDWord()
{
int  	iValue;


	if(!m_iDecode)
		{
		m_iOffset += 4;
		return m_pStream->ReadDWord();
		}


	Read(&iValue,4);


return iValue;
}

//*****************************************************************************
//*
//*		Read
//*
//*****************************************************************************
inline int CExcelImport::Read(void *pData,int iSize)
{
unsigned char  *pPtr;
unsigned		uOldBlock;
unsigned		uNewBlock;
unsigned		uOldPos;
unsigned		uNewPos;
int				iLeft;
int				iNum;
int				iRet;



	if(!m_iDecode)											// Bytes einlesen ohne Dekotierung
		{
		m_iOffset += iSize;
		return m_pStream->Read(pData,iSize);
		}


	if(m_iOldOff<m_iOffset)									// bersprunge Bytes dekodiern
		{
		uOldPos		= m_iOldOff%1024;
		uOldBlock	= m_iOldOff/1024;

		uNewPos		= m_iOffset%1024;
		uNewBlock	= m_iOffset/1024;

		if(uNewBlock!=uOldBlock || uNewPos<uOldPos || uOldPos==0)
			{
			m_sCodec.initCipher(uNewBlock);
			uOldPos = 0;
			}

		if(uNewPos>uOldPos)
			{
			m_sCodec.skip(uNewPos-uOldPos);
			}
		}


	pPtr	= (unsigned char*)pData;
	iNum	= 0;



    while(iSize>0)											// Bytes einlesen und dekodieren
		{
        iLeft	= 1024-m_iOffset%1024;

		if(iLeft>iSize)iLeft=iSize;

		iRet	= m_pStream->Read(pPtr,iLeft);

		if(iRet<iLeft)return -1;

		if(m_iOffset%1024==0)
			{
            m_sCodec.initCipher(m_iOffset/1024);
			}


		m_sCodec.decode(pPtr,pPtr,iLeft);

		m_iOffset  += iLeft;
		iSize	   -= iLeft;
        pPtr	   += iLeft;
        iNum       += iLeft;
		}



	m_iOldOff = m_iOffset;



return iNum;
}

//*****************************************************************************
//*
//*		SetPassword
//*
//*****************************************************************************
void CExcelImport::SetPassword(const zchar *pPassWd)
{
unsigned	uLen;
unsigned	uPos;


	memset(m_aPasswd,0,sizeof(m_aPasswd));

	uLen = strzlen(pPassWd);

	if(uLen>16)uLen=16;

	for(uPos=0;uPos<uLen;uPos++)
		{
		#ifdef UNICODE
		m_aPasswd[uPos] = pPassWd[uPos];
		#else
		m_aPasswd[uPos] = pPassWd[uPos]&0xFF;
		#endif
		}

}


//*****************************************************************************
//*
//*		ConvertString
//*
//*****************************************************************************
int CExcelImport::ConvertString(unsigned uSize,unsigned uFormat,unsigned char *pData)
{
unsigned	uPos;



	if(uFormat&1)											// UNICODE-Format
		{
		pData[uSize  ]=0;
		pData[uSize+1]=0;
		uSize /= 2;

		#ifndef UNICODE

		for(uPos=1;uPos<=uSize;uPos++)
			{
			if(!pData[uPos*2+1])
					pData[uPos]=pData[uPos*2];
			else	pData[uPos]=255;
			}

		#endif
		}
	else{													// ANSI-Format
		pData[uSize]=0;

		#ifdef UNICODE

		for(uPos=uSize;;)
			{
			pData[uPos*2  ] = pData[uPos];
			pData[uPos*2+1] = 0;
			uPos--;
			if(uPos==0)break;
			}

		#endif
		}


return uSize;
}

//*****************************************************************************
//*
//*		ImportDummy
//*
//*****************************************************************************
void _cdecl CExcelImport::ImportDummy(void *pParam,unsigned uSheet,unsigned uCol,unsigned uRow,int iType,const zchar *pData)
{

}

//*****************************************************************************
//*
//*		ImportData
//*
//*****************************************************************************
//	Ergibt 0 wenn der STream gelesen werden konnte bzw. eine Fehlernummer.
//				6 = Falsche BIFF-Version
//				7 = LOG-Datei konnte nicht geffnet werden
//				8 = Die Datei kann nicht decodiert werden
//				9 = Falsches Password
int CExcelImport::ImportData(CFileBuffer *pStream,const wchar_t *pDirName)
{
#if LOG_IN_FILE
FILE		   *pFile;
#endif
CStringChain	sSheetNames(sizeof(unsigned));
CStringChain	sStrings;
const zchar    *pName=Z("???");
zchar			cName[256];
unsigned char 	ucData[0x10004];
unsigned		uSheet=0;
unsigned		uStringFlag=0;
unsigned		uFormat;
unsigned		uTemp;
unsigned		uSize;
unsigned		uByte;
unsigned		uRow=0;
unsigned		uCol=0;
unsigned		uCnt;
unsigned		uAdd;
unsigned		uVal;
unsigned		uNum;
double			dValue;
int				i;



	m_pStream = pStream;


	   i = pStream->Read(cName,4);
	if(i!=4 || cName[0]!=9 || cName[1]!=8)
		{
		return 6;
		}

	uVal = *(unsigned short*)(cName+0);
	uNum = *(unsigned short*)(cName+2);

	pStream->Seek(uNum,SEEK_CUR);



	#if LOG_IN_FILE

	szprintf(cName,LOG_FILENAME".txt",pDirName);
	if(cName[7]<=' ')cName[7]='X';

		pFile=fopen(cName,"wb");							// Textdatei fr's loggen
	if(!pFile)
		{
		return 7;
		}

	#endif


	m_iOffset	= uNum+4;
	m_iDecode	= 0;
	m_iOldOff	= 0;


	for(;;)													// Alle Tokens laden
		{
		   i = pStream->Read(cName,4);
		if(i!=4)break;

		m_iOffset += 4;

		uVal = *(unsigned short*)(cName+0);
		uNum = *(unsigned short*)(cName+2);


		#if LOG_IN_FILE
		#if LOG_TOKENS
		pName = "???";

		for(i=0;aTokens[i].pName;i++)
			{
			if(aTokens[i].uVal!=uVal)continue;
			pName = aTokens[i].pName;
			break;
			}


//		printf (      "%04X  %007u [%5u]\t= \"%.34s\"  \n",uVal,pStream->Tell(),uNum,pName);
		fprintf(pFile,"%04X  %007u [%5u]\t= \"%s\"  \n"   ,uVal,pStream->Tell(),uNum,pName);
		fflush (pFile);

		#endif
		#endif



		switch(uVal)
			{
		case 0x002F:										// FILEPASS: File Is Password-Protected


				if(uNum<6)
					{
					return 8;
					}

				uRow	= ReadWord();
				uCol	= ReadWord();
				uVal	= ReadWord();
				uNum   -= 6;

				if(uVal!=1 || uRow!=1)
				if(uNum!=3*16)
					{
					return 8;
					}

				   i = Read(ucData,3*16);
				if(i!=3*16)return 8;

				uNum -= 3*16;

				m_sCodec.initKey(m_aPasswd,ucData+16*0);
															// Prfe den Dateinamen
				if(!m_sCodec.verifyKey(ucData+16*1,ucData+16*2))
					{
					return 9;
					}

				m_iDecode=1;

				break;


		case 0x00BD:										// MULRK: Multiple RK Cells


				if(uNum<12)break;

				uRow	= ReadWord();
				uCol	= ReadWord();
				uNum   -= 6;

				while(uNum>=6)
					{
					uFormat	=	ReadWord ();
					uTemp	=	ReadDWord();
					uNum   -=   6;

					if(uTemp&2)
						{
						dValue = ((int)uTemp)>>2;
						}
					else{
						((unsigned*)&dValue)[0] = 0;
						((unsigned*)&dValue)[1] = uTemp&~3;
						}

					if(uTemp&1)dValue*=100.0;

					#if LOG_IN_FILE
					fprintf(pFile,"[%u,%03u,%03u] = %.15g\n",uSheet,uRow,uCol,dValue);
					#endif

					szprintf(cName,Z("%.15g"),dValue);
					m_pCallbackProc(m_pCallbackParam,uSheet,uCol,uRow,CEI_TYPE_FLOAT+(uTemp&3),cName);

					uCol++;
					}

				uTemp = ReadWord();
				break;


		case 0x0006:										// FORMULAR: Cell Formula


				if(uNum<12)break;

				uRow	= ReadWord();
				uCol	= ReadWord();
				uFormat	= ReadWord();
						  Read(ucData,8);

				uNum   -= 6+8;

				if(ucData[6]!=0xFF || ucData[7]!=0xFF)
					{
					#if LOG_IN_FILE
					fprintf(pFile,"[%u,%03u,%03u] = %.15g\n",uSheet,uRow,uCol,*(double*)ucData);
					#endif

					szprintf(cName,Z("%.15g"),*(double*)ucData);
					m_pCallbackProc(m_pCallbackParam,uSheet,uCol,uRow,CEI_TYPE_NUMBER_1,cName);
					}
				else if(ucData[0]==1)
					{
					#if LOG_IN_FILE
					fprintf(pFile,"[%u,%03u,%03u] = %s\n",uSheet,uRow,uCol,(ucData[2])? "TRUE":"FALSE");
					#endif

					szprintf(cName,Z("%u"),ucData[2]);
					m_pCallbackProc(m_pCallbackParam,uSheet,uCol,uRow,CEI_TYPE_BOOL,cName);
					}
				else if(ucData[0]==2)
					{
					#if LOG_IN_FILE
					fprintf(pFile,"[%u,%03u,%03u] = #Error%u#\n",uSheet,uRow,uCol,ucData[2]);
					#endif

					szprintf(cName,Z("%u"),ucData[2]);
					m_pCallbackProc(m_pCallbackParam,uSheet,uCol,uRow,CEI_TYPE_ERROR,cName);
					}
				else if(ucData[0]==0)
					{
					uStringFlag=1;
					}


				break;


		case 0x0207:										// STRING: String Value of a Formula


				if(uNum<3 || !uStringFlag)break;

				uStringFlag = 0;


				uSize	= ReadWord();
				uFormat	= ReadByte();
				uNum   -= 3;

				Read(ucData,uNum);

				uSize   = ConvertString(uNum,uFormat,ucData);
				uNum    = 0;

				#if LOG_IN_FILE
				fprintf(pFile,"[%u,%03u,%03u] = %"S"\n",uSheet,uRow,uCol,ucData);
				#endif

				m_pCallbackProc(m_pCallbackParam,uSheet,uCol,uRow,CEI_TYPE_TEXT,(zchar*)ucData);

				break;


		case 0x00FC:										// SST: Shared String Table


				uTemp	= ReadDWord();
				uCnt	= ReadDWord();
				uNum   -= 8;

				if(uCnt>0x10000)
					{
					return 8;
					}

				while(uCnt>0)
					{
					if(uNum<3)
						{
						Read(cName,uNum);
						uByte = uNum;
						uVal  = pStream->ReadWord();
						uNum  = pStream->ReadWord();

						m_iOffset += 4;

						if(uVal!=0x3C)return 8;				// CONTINUE: Continues Long Records

						Read(cName+uByte,3-uByte);
						uNum -= 3-uByte;
						}
					else{
						Read(cName,3);
						uNum -= 3;
						}

					uSize	= *(unsigned short*)cName;
					uFormat	= cName[2];
					uAdd    = 0;

					if(uFormat&1)uSize*=2;					// Unicode Text
					if(uFormat&8)							// Richtext Formating
					if(uNum>2)
						{
						Read(cName+3,2);
						uAdd   = *(unsigned short*)(cName+3);
						uSize += uAdd*4;
						uNum  -= 2;
						}


					if(uSize>uNum)							// Ist das Feld zu klein
						{
						Read(ucData,uNum);

						uByte = uNum;
						uVal  = pStream->ReadWord();
						uNum  = pStream->ReadWord();

						m_iOffset += 4;

						if(uVal!=0x3C)						// CONTINUE: Continues Long Records
							{
							return 8;				
							}

						// REM AZ Fehler wenn sich das Format ndert
						uFormat = ReadByte();
						Read(ucData+uByte,uSize-uByte);
						uNum   -= uSize-uByte+1;
						}
					else{									// Das Feld ist noch gro genug
						Read(ucData,uSize);
						uNum   -= uSize;
						}


					uSize = ConvertString(uSize-uAdd*2,uFormat,ucData);
					sStrings.Add(uSize,(zchar*)ucData);
					uCnt--;
					}
			
				break;


		case 0x00FD:										// LABELSST: Cell Value, String Constant/SST


				if(uNum<10)break;

				uRow	= ReadWord();
				uCol	= ReadWord();
				uFormat	= ReadWord();
				uTemp	= ReadDWord();
				uNum   -= 10;

				#if LOG_IN_FILE
				fprintf(pFile,"[%u,%03u,%03u] = %"S"\n",uSheet,uRow,uCol,sStrings[uTemp]);
				#endif

				m_pCallbackProc(m_pCallbackParam,uSheet,uCol,uRow,CEI_TYPE_TEXT,sStrings[uTemp]);

				break;


		case 0x0085:										// BOUNDSHEET: Sheet Information


				if(uNum<7)break;

				uTemp	= pStream->ReadDWord();m_iOffset+=4;
				uFormat	= ReadWord();
				uSize   = ReadByte();
				uNum   -= 7;

				if(uNum<1)break;

				ReadByte();uNum--;
				Read(ucData,uNum);

				uSize   = ConvertString(uNum,uFormat,ucData);
				uNum	= 0;

				sSheetNames.Add(uSize,(zchar*)ucData,CSC_END,&uTemp);

				#if LOG_IN_FILE
				fprintf(pFile,"Sheet %u = %"S" at %u\n",sSheetNames.Count(),ucData,uTemp);
				#endif

				m_pCallbackProc(m_pCallbackParam,sSheetNames.Count(),0,0,CEI_TYPE_SHEET,(zchar*)ucData);

				break;


		case 0x027E:										// RK: Contains an RK value


				if(uNum<10)break;

				uRow	= ReadWord();
				uCol	= ReadWord();
				uFormat	= ReadWord();
				uTemp	= ReadDWord();
				uNum   -= 10;


				if(uTemp&2)
					{
					dValue = ((int)uTemp)>>2;
					}
				else{
					((unsigned*)&dValue)[0] = 0;
					((unsigned*)&dValue)[1] = uTemp&~3;
					}

				if(uTemp&1)dValue*=100.0;

				#if LOG_IN_FILE
				fprintf(pFile,"[%u,%03u,%03u] = %.15g\n",uSheet,uRow,uCol,dValue);
				#endif

				szprintf(cName,Z("%.15g"),dValue);
				m_pCallbackProc(m_pCallbackParam,uSheet,uCol,uRow,CEI_TYPE_FLOAT+(uTemp&3),cName);

				break;


		case 0x0809:										// BOF: Beginning of File


				uTemp  = pStream->Tell();
				uTemp -= 4;

				for(uSheet=sSheetNames.Count();uSheet>0;uSheet--)
					{
					if(sSheetNames.DataGet(uSheet-1)==(int)uTemp)break;
					}

				// if(uSheet==0) error

				break;


		case 0x0203:										// NUMBER: Cell Value, Floating-Point Number


				if(uNum<14)break;

				uRow	= ReadWord();
				uCol	= ReadWord();
				uFormat	= ReadWord();
						  Read(&dValue,8);

				uNum   -= 14;


				#if LOG_IN_FILE
				fprintf(pFile,"[%u,%03u,%03u] = %.15g\n",uSheet,uRow,uCol,dValue);
				#endif

				szprintf(cName,Z("%.15g"),dValue);
				m_pCallbackProc(m_pCallbackParam,sSheetNames.Count(),0,0,CEI_TYPE_SHEET,cName);

				break;
			}



		if(uNum&0x80000000)									// Zu viele Bytes wurden dekodiert
			{
			return 8;
			}

		pStream->Seek(uNum,SEEK_CUR);
		m_iOffset+=uNum;
		}


	#if LOG_IN_FILE
	fclose(pFile);
	#endif



return 0;
}
