//*****************************************************************************
//*
//*
//*		ExcelImport.h
//*
//*
//*****************************************************************************
#ifndef 	__EXCELIMPORT_H__
#define 	__EXCELIMPORT_H__


#include	"MapFile.h"
#include	"FileBuffer.h"
#include	"BinaryCodec.h"


#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif




#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	Z(a)		L##a
#define 	zchar		wchar_t
#define 	strzlen		wcslen
#else
#define 	Z(a)		a
#define 	zchar		char
#define 	strzlen		strlen
#endif


#define 	CEI_TYPE_SHEET		0					// Callback fr Blattnamen
#define 	CEI_TYPE_TEXT		1					// Callback fr Textzelle
#define 	CEI_TYPE_NUMBER		2					// Callback fr double Wert
#define 	CEI_TYPE_FLOAT		3					// Callback fr UINT Wert als double mit 30-Bit
#define 	CEI_TYPE_FIXED		4					// Callback fr UINT Wert als int    mit 30-Bit
#define 	CEI_TYPE_FLOAT_100	5					// Callback fr UINT Wert als double mit 30-Bit
#define 	CEI_TYPE_FIXED_100	6					// Callback fr UINT Wert als int    mit 30-Bit
#define 	CEI_TYPE_NUMBER_1	7					// Callback fr double Wert ohne :FF FF in Byte 6,7
#define 	CEI_TYPE_BOOL		8					// Callback fr ein Byte BOOL Wert
#define 	CEI_TYPE_ERROR		9					// Callback fr ein Byte Fehler Wert


typedef void (_cdecl *ExcelImportCB)(void *pParam,unsigned uSheet,unsigned uCol,unsigned uRow,int iType,const zchar *pData);

	
//*****************************************************************************
//*
//*		CExcelImport
//*
//*****************************************************************************
class CExcelImport
{
public:	

	CExcelImport();
   ~CExcelImport();

	int					Open(const zchar *pFilename);
	void				SetCallback(void *pParam,ExcelImportCB pProc);


protected:

	typedef struct  
		{ 
		CFileBuffer		sStream;	
		char		   *pBaseData;		
		unsigned	   *pFatEntries;
		unsigned	   *pMinAddress;
		unsigned		uStartSector;
		unsigned		uSectorCount;
		unsigned		uSectorSize;
		unsigned		uStreamSize;
		unsigned		uOffset;	
		unsigned		uSector;
		unsigned		uIsMin;
		}BufferStream;

	CFileBuffer		   *CreateStream(unsigned uStart,unsigned uLength,bool bUseMin=0);	
	int					DeleteStream(CFileBuffer *pStream);	
	int					ImportData  (CFileBuffer *pStream,const wchar_t *pDirName);
	void				SetPassword (const zchar *pPassWd);
	void				Clear();

	int					ReadByte();
	int					ReadWord();
	int					ReadDWord();
	int					Read(void *pData,int iSize);

	static  void _cdecl ImportDummy(void *pParam,unsigned uSheet,unsigned uCol,unsigned uRow,int iType,const zchar *pData);
	static	int  _cdecl	StreamRead (void *pHandel,void *pBuffer,int iCount);
	static	int  _cdecl	StreamSeek (void *pHandel,int   iPos   ,int iMode );
	static	int			ConvertString(unsigned uSize,unsigned uFormat,unsigned char *pData);


	CMapFile			m_sFile;
	unsigned			m_uFileSize;	 
	unsigned			m_uSecSize;
	unsigned			m_uMinSize;
	unsigned			m_uFatCount;
	unsigned			m_uMinCount;
	unsigned		   *m_pFatList;
	unsigned		   *m_pMinList;
	unsigned		   *m_pMinAddr;
	char			   *m_pFileMem;
	CFileBuffer        *m_pStream;
	unsigned short		m_aPasswd[16];
	void			   *m_pCallbackParam;	
	ExcelImportCB		m_pCallbackProc;	
	BinaryCodec_RCF		m_sCodec;
	int 				m_iDecode;
	int					m_iOldOff;
	int					m_iOffset;

};



#ifdef		Z
#undef 		Z
#endif


#endif 	



