//*****************************************************************************
//*
//*
//*		Main.cpp
//*
//*
//*****************************************************************************
#include		<conio.h>
#include		<stdio.h>
#include		"ExcelImport.h"
#include		"StringChain.h"

CStringChain	sCells;		
CStringChain	sSheet;

typedef	int (_cdecl *pprintf_proca)(void *pParam,const char    *pBuffer,int iSize);
typedef	int (_cdecl *pprintf_procw)(void *pParam,const wchar_t *pBuffer,int iSize);

typedef struct
	{
	char   *pBuffer;
	int		iSize;
	int		iPos;
	int		iNew;
	}PrintfData;


//*****************************************************************************
//*
//*		pprintf
//*
//*****************************************************************************
int _cdecl pprintf(void *pParam,pprintf_proca pProc,const char **pFormatPtr,va_list *pList)
{
PrintfData	*pData=(PrintfData*)pParam;

	pData->iPos = _vsnprintf(pData->pBuffer,pData->iSize,*pFormatPtr,*pList);

return pData->iPos;
}

//*****************************************************************************
//*
//*		pprintf
//*
//*****************************************************************************
int _cdecl pprintf(void *pParam,pprintf_procw pProc,const unsigned short **pFormatPtr,va_list *pList)
{
PrintfData	*pData=(PrintfData*)pParam;

	pData->iPos = _vsnwprintf((wchar_t*)pData->pBuffer,pData->iSize,(wchar_t*)*pFormatPtr,*pList);

return pData->iPos;
}

//*****************************************************************************
//*
//*		memgcmp
//*
//*****************************************************************************
int memgcmp(const char *pBuffer1,const char *pBuffer2)
{
	return stricmp(pBuffer1,pBuffer2);
}
int	memgcmp(const unsigned short *pBuffer1,const unsigned short *pBuffer2)
{
	return  wcsicmp((wchar_t*)pBuffer1,(wchar_t*)pBuffer2);
}

int	memgcmp(const char *pBuffer1,const char *pBuffer2,int iCount)
{
	return  memicmp(pBuffer1,pBuffer2,iCount);
}

int	memgcmp(const unsigned short *pBuffer1,const unsigned short *pBuffer2,int iCount)
{
	return  memicmp(pBuffer1,pBuffer2,iCount*2);
}

//*****************************************************************************
//*
//*		ImportCallback
//*
//*****************************************************************************
//	Callback Funktion um die Zellininhalte zu erhalten
//	pParam		: Userparameter von SetCallback(...) 
//	uSheet		: Nummer des Plattes 
//	uCol		: Spaltennummer
//	uRow		: Zeilennummer
//	iType		: Art des Eintrages (siehe CEI_TYPE_????)
//	pData		: Zeiger auf den Zellen Text.
void ImportCallback(void *pParam,unsigned uSheet,unsigned uCol,unsigned uRow,int iType,const char *pData)
{
int		iPos;



	if(uSheet==0)return;

	if(iType==CEI_TYPE_SHEET)
		{
		sSheet.Add(pData,CSC_END,&uSheet);
		}
	else{
		iPos  = uSheet<<28;	
		iPos |= uRow<<10;
		iPos |= uCol;

		sCells.Add(pData,CSC_END,&iPos);
		}

}


//*****************************************************************************
//*															  
//*		main												  
//*
//*****************************************************************************
int main(int iArgc,char **pArgv)
{
char				cText[1024];
FILE			   *pFile;	
CExcelImport		sExcel;
unsigned			uError;
unsigned			uSheetO;
unsigned			uSheet;
unsigned			uData;
unsigned			uColO;
unsigned			uRowO;
unsigned			uCol;
unsigned			uRow;
int					iVal;
int					iPos;


	sCells.DataLength(sizeof(int));		
	sSheet.DataLength(sizeof(int));	

	sExcel.SetCallback(0,ImportCallback);
	uError = sExcel.Open("D:\\Test.xls");

	switch(uError)
		{
	case 0:																		break;
	case 1:	printf("\nDatei konnte nicht geffnet werden.\n\n");				return -1;
	case 2:	printf("\nFalsches Dateiformat..\n\n");								return -1;
	case 3:	printf("\nBigEndian wird nicht untersttzt.\n\n");					return -1;
	case 4:	printf("\nZu wenig Speicher..\n\n");								return -1;
	case 5:	printf("\nDie Datei wird von einem anderen Programm benutzt..\n\n");return -1;
	case 6:	printf("\nFalsche BIFF-Version.\n\n");								return -1;
	case 7:	printf("\nLOG-Datei konnte nicht geffnet werden.\n\n");			return -1;
	case 8:	printf("\nDie Datei kann nicht decodiert werden.\n\n");				return -1;
	case 9:	printf("\nFalsches Password.\n\n");									return -1;
	default:printf("\nUnbekannnter Fehler %u.\n\n",uError);						return -1;
		}
	

	
	sCells.Sort(0,-1,CSC_SORT_UINT);		
	sSheet.Sort(0,-1,CSC_SORT_UINT);		
	
	uSheetO	= 0xFFFFFFFF;
	uColO	= 0;
	uRowO	= 0;
	pFile	= 0;

	for(iPos=0;iPos<sCells.Count();iPos++)						// Alle Zellen ausgeben
		{
		uData	= sCells.DataGet(iPos);

		uSheet	= (uData>>28)&0x0000F;
		uRow	= (uData>>10)&0x3FFFF;
		uCol	= (uData    )&0x003FF;
		
		if(uSheetO!=uSheet)										// Neues Blatt
			{
			if(pFile)fclose(pFile);
			
			iVal	= sSheet.Find(uSheet);
			sprintf(cText,"D:\\Test.%s.csv",sSheet[iVal]);
			pFile	= fopen(cText,"wb");

			uSheetO	= uSheet;
			uColO	= 0;
			uRowO	= 0;
			} 


		if(!pFile)continue;

		
		while(uRowO<uRow)										// Neue Zeile
			{
			fprintf(pFile,"\n");
			uRowO++;
			uColO=0;
			}

		while(uColO<uCol)										// Neue Spalte
			{
			fprintf(pFile,";");
			uColO++;
			}
		
		
		if(uColO<uCol)continue;

		iVal = sCells.Get(iPos,cText,sizeof(cText));

		for(iVal--;iVal>=0;iVal--)								// Spezialzeichen umbenennen
			{
			if(cText[iVal]>  0 )
			if(cText[iVal]< ' ')cText[iVal]='.';
			if(cText[iVal]=='"')cText[iVal]='.';
			}

		fprintf(pFile,"%s;",cText);
		uColO++;
		}
	

	if(pFile)fclose(pFile);


	printf("\nDatei wurde importiert.\n\n");


return 0;
}